#include "sys/alt_stdio.h"
#include "system.h"
#include "alt_types.h"
#include "sys/alt_irq.h"
#include "altera_avalon_timer_regs.h"
#define GPO      (*(volatile unsigned int *) PIO_0_BASE)

int pit_cnt=0;
volatile int timer_capture;
int lp;
int n;
int n2;
//K
int tone_array[9]={0x0,0x1a7,0x179,0x150,0x13d,0x11a,0xfb,0xe0,0xd3};
//JG̍@yf[^
char music_array[256]={1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,3,3,3,3,2,2,2,2,1,1,1,1,0,0,0,0,
		              3,3,3,3,4,4,4,4,5,5,5,5,6,6,6,6,5,5,5,5,4,4,4,4,3,3,3,3,0,0,0,0,
		              1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,
		              1,0,1,0,2,0,2,0,3,0,3,0,4,0,4,0,3,3,0,0,2,2,0,0,1,1,0,0,0,0,0,0,
		              0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		              0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};

void wr_func_de0(int adr,int wdata){
	  GPO = (0x700 | adr);
	  GPO = adr;
	  GPO = adr;
	  GPO = (0x600 | adr);
	  GPO = (0x700 | wdata);
	  GPO = (0x100 | wdata);
	  GPO = (0x100 | wdata);
	  GPO =(0x700 | wdata);
}

void set_tone(alt_u32 reg_num,int num){
	int tone;
    tone=tone_array[(int)music_array[num]];
    alt_printf("m1 tone = %x \n\r",tone);
    wr_func_de0( reg_num,(tone&0xff));
    wr_func_de0( reg_num+1,(tone>>8));
}

void Timer_isr()
{
	set_tone(0,pit_cnt);
	if(pit_cnt<32)
	  lp = 160 + pit_cnt;
	else
	  lp = pit_cnt - 32;
	set_tone(2,lp);
	if(pit_cnt<64)
	  lp = 128 + pit_cnt;
	else
	  lp = pit_cnt - 64;
	set_tone(4,lp);
	//LED
	if (0x1 & pit_cnt)
      GPO = 0x80000000;
	else
	  GPO = 0x0;
	if(pit_cnt>192)
	  pit_cnt = 0;
	else
	  pit_cnt++;
    //荞݃NA
    IOWR_ALTERA_AVALON_TIMER_STATUS( TIMER_0_BASE , 0);
}

int main()
{
alt_u32 timer_value;
GPO = 0x0600 ;
//volume
wr_func_de0(0xa,0xd);//wr r10
//Timer handler
alt_irq_register(TIMER_0_IRQ,0,Timer_isr);
//Timer
timer_value = 5000000 ;
IOWR_ALTERA_AVALON_TIMER_PERIODL(TIMER_0_BASE, timer_value & 0xffff);
IOWR_ALTERA_AVALON_TIMER_PERIODH(TIMER_0_BASE, (timer_value >> 16) & 0xffff);
IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER_0_BASE, 0x07);
alt_ic_irq_enable( TIMER_0_IRQ_INTERRUPT_CONTROLLER_ID,TIMER_0_IRQ);
while(1);
return 0;
}
